<template>
  <section
    class="ui-accordion ui-box-corners uikit-p-0 uikit-overflow-hidden uikit-transition-all uikit-duration-500 uikit-rounded-10 uikit-text-white"
    :class="{ '-open': isOpen }"
  >
    <div
      @click="toggle"
      class="header uikit-px-18 uikit-flex uikit-items-center uikit-justify-between uikit-cursor-pointer uikit-text-ui-page-description"
    >
      <span>{{ title }}</span>
      <ui-async-icon-pixel-arrow
        class="arrow uikit-flex-shrink-0 uikit-transition-transform uikit-duration-150 uikit-ml-12 uikit-w-12 uikit-h-12"
      />
    </div>
    <div class="uikit-px-18 uikit-pt-12 uikit-pb-32 uikit-text-white uikit-text-opacity-50">
      <slot />
    </div>
  </section>
</template>

<script lang="ts">
  import { defineComponent } from 'vue'
  import { useToggle } from '@vueuse/core'
  import { UiAsyncIconPixelArrow } from '../UiIcon'

  export default defineComponent({
    name: 'ui-accordion',
    components: {
      UiAsyncIconPixelArrow,
    },
    props: {
      title: {
        type: String,
        required: true,
      },
    },
    setup() {
      const [isOpen, toggle] = useToggle()

      return { isOpen, toggle: () => toggle() }
    },
  })
</script>

<style>
  .ui-accordion:not(.-open) {
    max-height: 88px;
    overflow-anchor: none;
  }

  .ui-accordion.-open {
    @apply uikit-bg-white uikit-bg-opacity-5;

    max-height: 1000px;
    height: auto;
  }

  .ui-accordion > .header {
    height: 88px;
  }

  .ui-accordion.-open > .header > .arrow {
    transform: scale(-100%);
  }
</style>
